/****************************************************************************
 * USB Loader GX Team
 *
 * libwiigui Template
 * by Tantric 2009
 *
 * menu.cpp
 * Menu flow routines - handles all menu logic
 ***************************************************************************/
///////////////////////////////////////////
//	Direct Loader GX
//		modified by kurenai 2009.07
///////////////////////////////////////////
#include <gccore.h>

#include "mload/mload.h"
#include "patches/patchcode.h"
#include "menu.h"
#include "sys.h"
#include "fatmounter.h"

/*** Variables that are also used extern ***/
u8 mountMethod=0;

/****************************************************************************
 * MainMenu
 ***************************************************************************/
int MainMenu(char* id)
{
	int ret = 0;
    u8 header[6];
	header[0] = id[0];
	header[1] = id[1];
	header[2] = id[2];
	header[3] = id[3];
	header[4] = id[4];
	header[5] = id[5];

    struct Game_CFG* game_cfg = CFG_get_game_opt(header);

    if (game_cfg) {
        videoChoice = game_cfg->video;
        languageChoice = game_cfg->language;
        ocarinaChoice = game_cfg->ocarina;
        viChoice = game_cfg->vipatch;
        fix002 = game_cfg->errorfix002;
        iosChoice = game_cfg->ios;
        countrystrings = game_cfg->patchcountrystrings;
	if ( game_cfg->alternatedolstart != 0 ) {
		alternatedol = game_cfg->loadalternatedol;
		alternatedoloffset = game_cfg->alternatedolstart;
	}
        reloadblock = game_cfg->iosreloadblock;
    } else {
        videoChoice = Settings.video;
        languageChoice = Settings.language;
        ocarinaChoice = Settings.ocarina;
        viChoice = Settings.vpatch;
		if(Settings.cios == ios222) {
        iosChoice = i222;
		} else {
		iosChoice = i249;
		}
        fix002 = Settings.error002;
        countrystrings = Settings.patchcountrystrings;
	alternatedol = off;
	alternatedoloffset = 0;
        reloadblock = off;
    }
    int ios2;
    switch(iosChoice) {
            case i249:
                ios2 = 249;
                break;

            case i222:
                ios2 = 222;
                break;

            case i223:
                ios2 = 223;
                break;

            default:
                ios2 = 249;
                break;
    }

	if(IOS_GetVersion() != ios2) {
		ret = Sys_IosReload(ios2);
		if(ret < 0) {
			Sys_IosReload(249);
		}
	}
    ret = Disc_SetUSB(header);
    if(ret < 0) Sys_BackToLoader();
    ret = Disc_Open();
    if(ret < 0) Sys_BackToLoader();

    SDCard_deInit();
	USBDevice_deInit();

	if(reloadblock == on && (IOS_GetVersion() == 222 || IOS_GetVersion() == 223)) {
        patch_cios_data();
        mload_close();
	}

    u8 errorfixer002 = 0;
    switch(fix002)
    {
        case on:
            errorfixer002 = 1;
            break;
        case off:
            errorfixer002 = 0;
			break;
		case anti:
			errorfixer002 = 2;
            break;
    }

   switch(languageChoice)
    {
                        case ConsoleLangDefault:
                                configbytes[0] = 0xCD;
                        break;

                        case jap:
                                configbytes[0] = 0x00;
                        break;

                        case eng:
								configbytes[0] = 0x01;
                        break;

                        case ger:
                                configbytes[0] = 0x02;
                        break;

                        case fren:
                                configbytes[0] = 0x03;
                        break;

                        case esp:
                                configbytes[0] = 0x04;
                        break;

                        case it:
                                configbytes[0] = 0x05;
                        break;

                        case dut:
                                configbytes[0] = 0x06;
                        break;

                        case schin:
                                configbytes[0] = 0x07;
                        break;

                        case tchin:
                                configbytes[0] = 0x08;
                        break;

                        case kor:
                                configbytes[0] = 0x09;
                        break;
                        //wenn nicht genau klar ist welches
                        default:
                                configbytes[0] = 0xCD;
                        break;
    }

    u8 videoselected = 0;

    switch(videoChoice)
    {
                        case discdefault:
                            videoselected = 0;
                        break;

                        case pal50:
                            videoselected = 1;
                        break;

                        case pal60:
                            videoselected = 2;
                        break;

                        case ntsc:
                            videoselected = 3;
						break;

                        case systemdefault:
                            videoselected = 4;
                        break;

                        case patch:
                            videoselected = 5;
                        break;

                        default:
                            videoselected = 0;
                        break;
    }

    u32 cheat = 0;
    switch(ocarinaChoice)
    {
                        case on:
                                cheat = 1;
                        break;

                        case off:
                                cheat = 0;
                        break;

                        default:
                                cheat = 1;
                        break;
    }

    u8 vipatch = 0;
    switch(viChoice)
    {
                        case on:
                                vipatch = 1;
                        break;

                        case off:
                                vipatch = 0;
                        break;

                        default:
                                vipatch = 0;
                        break;
    }

    ret = Disc_WiiBoot(videoselected, cheat, vipatch, countrystrings, errorfixer002, alternatedol, alternatedoloffset);
    if (ret < 0) {
        Sys_LoadMenu();
    }

    return 0;
}
